<template>
  <div>
    <template v-if="isPurchased">
      <lesson-content :lesson="lesson"/>
    </template>
    <template v-else>
      <v-container>
        <v-row dense>
          <v-col cols="12">
            <v-card>
              <v-card-title color="primary">
                Получите доступ!
              </v-card-title>
              <v-card-text>
                <p class="white--text">
                  Для того что бы получить доступ к уроку приобретите курс <b>{{ course.content.name }}</b> за <b>{{ ldsPrice }} LDS </b>
                </p>
              </v-card-text>
              <course-list-item :course="course">
                <template slot="button">
                  <v-btn color="primary" block small @click="buy" :disabled='disabled'>Купить | {{ ldsPrice }} LDS</v-btn>
                </template>
              </course-list-item>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </template>
  </div>
</template>

<script lang="ts">

import Vue from "vue";
import Component from "vue-class-component";
import { Lesson } from "@/domain/entity/lesson/Lesson";
import { Prop } from "vue-property-decorator";
import LessonContent from "./LessonContent.vue";
import { PurchaseCourse } from "@/domain/entity/purchase/course/PurchaseCourse";
import CourseListItem from "@/components/courses/CourseListItem.vue";
import { AuthInfoResponse } from "@/domain/response/auth/info/AuthInfoResponse";
import { CourseBuyLdsCommand, CourseResponse } from '@/api/courses';

@Component({
  components: {
    LessonContent,
    CourseListItem
  }
})
export default class LessonContentPurchase extends Vue {
  @Prop({
    required: true,
    type: Object
  })
  private readonly lesson!: Lesson;

  @Prop({
    required: false,
    type: Array,
    default: () => []
  })
  private readonly purchases!: PurchaseCourse[];

  @Prop({
    required: true,
    type: Object
  })
  private readonly course!: CourseResponse;

  private disabled: boolean = false;

  private get isPurchased (): boolean {
    return this.purchases.some(item => item.isPaid && item.courseId === this.lesson.courseId);
  }

  private get userId (): string {
    const info: AuthInfoResponse|null = this.$store.getters['auth/info'];
    if (!info) {
      return "";
    }
    return info.id;
  }

  public async buy (): Promise<void> {
    try {
      this.disabled = true;
      await this.$store.dispatch("purchasesCourse/buy", {
        courseId: this.course.id
      } as CourseBuyLdsCommand);
    } finally {
      this.disabled = false;
    }
  }

  private get ldsPrice(): number {
    return Number(BigInt(this.course.prices.lds) / BigInt(10 ** 18));
  }
}

</script>

<style scoped>

</style>
